library ieee;
use ieee.std_logic_1164.all;

entity booth_encoder is
	port(
		-- input signals
		b	: in std_logic_vector(31 downto 0);
		a	: in std_logic_vector(31 downto 0);

		-- output signals
		pp1	: out std_logic_vector(35 downto 0);
		pp2	: out std_logic_vector(36 downto 0);
		pp3	: out std_logic_vector(36 downto 0);
		pp4	: out std_logic_vector(36 downto 0);
		pp5	: out std_logic_vector(36 downto 0);
		pp6	: out std_logic_vector(36 downto 0);
		pp7	: out std_logic_vector(36 downto 0);
		pp8	: out std_logic_vector(36 downto 0);
		pp9	: out std_logic_vector(36 downto 0);
		pp10	: out std_logic_vector(36 downto 0);
		pp11	: out std_logic_vector(36 downto 0);
		pp12	: out std_logic_vector(36 downto 0);
		pp13	: out std_logic_vector(36 downto 0);
		pp14	: out std_logic_vector(36 downto 0);
		pp15	: out std_logic_vector(36 downto 0);
		pp16	: out std_logic_vector(35 downto 0);
		pp17	: out std_logic_vector(33 downto 0)

	);
end booth_encoder;

architecture behaviour of booth_encoder is

	component pp_create is
		port(
			-- input signals
			b	: in std_logic_vector(2 downto 0);
			a	: in std_logic_vector(31 downto 0);

			-- output signals
			s	: out std_logic;
			pp	: out std_logic_vector(32 downto 0)
		);
	end component;

	-- extended multiplicand
	signal b_int	: std_logic_vector(b'length + 2 downto 0);

	-- partial products generated by the pp_create component
	type matrix_17x33 is array(16 downto 0) of std_logic_vector(32 downto 0);
	signal pp_int	: matrix_17x33;

	-- sign bits
	signal s	: std_logic_vector(16 downto 0);

begin

	-- extend the multiplicand
	b_int <= "00" & b & '0';


	-- generation of the internal partial products
	generate_internal_pp:
	for i in 0 to 16 generate
		pp1_create : pp_create port map(
			-- input signals
			b	=> b_int(2*i+2 downto 2*i),
			a	=> a,

			-- output signals
			s	=> s(i),
			pp	=> pp_int(i)
		);
	end generate generate_internal_pp;


	-- sign extension
	pp1	<= not(s(0)) & s(0) & s(0) & pp_int(0);
	pp2	<= '1' & not(s(1)) & pp_int(1) & '0' & s(0);
	pp3	<= '1' & not(s(2)) & pp_int(2) & '0' & s(1);
	pp4	<= '1' & not(s(3)) & pp_int(3) & '0' & s(2);
	pp5	<= '1' & not(s(4)) & pp_int(4) & '0' & s(3);
	pp6	<= '1' & not(s(5)) & pp_int(5) & '0' & s(4);
	pp7	<= '1' & not(s(6)) & pp_int(6) & '0' & s(5);
	pp8	<= '1' & not(s(7)) & pp_int(7) & '0' & s(6);
	pp9	<= '1' & not(s(8)) & pp_int(8) & '0' & s(7);
	pp10	<= '1' & not(s(9)) & pp_int(9) & '0' & s(8);
	pp11	<= '1' & not(s(10)) & pp_int(10) & '0' & s(9);
	pp12	<= '1' & not(s(11)) & pp_int(11) & '0' & s(10);
	pp13	<= '1' & not(s(12)) & pp_int(12) & '0' & s(11);
	pp14	<= '1' & not(s(13)) & pp_int(13) & '0' & s(12);
	pp15	<= '1' & not(s(14)) & pp_int(14) & '0' & s(13);
	pp16	<= not(s(15)) & pp_int(15) & '0' & s(14);
	pp17	<= pp_int(16)(31 downto 0) & '0' & s(15);

end architecture behaviour;
